public class SPSJava{
  static byte PINB;   // EingabePort
  static byte PORTB;  // Ausgabe
  static byte merker; // Merker
  static void simulation(){  // Simulation des Schaltnetzes
    if((PINB&3)==3){ // PB1 && PB0 ?
     PORTB |= 4;  // PB2 <- 1
    }
    else {
     PORTB &=~4;  // PB2 <- 0
    }
  }
  static void test(){  // Ausgabe der Wertetabelle
    test(3);         // 
  }
  static void test(int b){ // b Anzahl Bits in Ausgabe
    test(b,b);
  }
  static void test(int eb,int ab){ // eb #Eingangsbits ab #Ausgangsbits
    String es="\f Zn|";            // \f loescht Konsole
    String as;
    for(int i=eb-1;i>=0;i--){  // Tabellenueberschrift Eingaenge erzeugen
      es=es+"PB"+i+' ';
    }
    es+="|";
    for(int i=ab-1;i>=0;i--){  // Tabellenueberschrift Ausgaenge erzeugen
      es=es+"PB"+i+' ';
    }
    System.out.println(es);
    for(byte i=0;i<Math.pow(2,eb);i++){ // SPS wird fuer alle Kombinationen aufgerufen
      es=intToString2(i,eb);
      PORTB=PINB=i;
      simulation();
      as=intToString2(PORTB,ab);
      System.out.printf("%3d|%s|%s %n",i,es,as);  
    }  
  }
  static String intToString2(int n,int a){ // formatierte Bitausgabe
    String s="";                           // n ist die auszugebende Zahl
    for(int i=0;i<a;i++){                  // a sind die Anzahl der Stellen
      if(n%2>0)
        s=" 1  "+s;
      else
        s=" 0  "+s;
      n/=2;  
    }
    return s;
  }
}